//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnFreqClick(TObject *Sender)
{
  TLargeInteger L;

  if (QueryPerformanceFrequency(&L))
    ShowMessage("Frequency: " + IntToStr(L.QuadPart));
  else
    ShowMessage("This system doesn't support high-resolution performance counter !!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnCounterClick(TObject *Sender)
{
  TLargeInteger L;

  if (QueryPerformanceCounter(&L))
    ShowMessage("Counter: " + IntToStr(L.QuadPart));
  else
    ShowMessage("This system doesn't support high-resolution performance counter !!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnStartClick(TObject *Sender)
{
  TLargeInteger Start, L;
  int Freq;

  QueryPerformanceFrequency(&L);
  Freq = L.QuadPart / 1000;

  bStopCounter = false;
  QueryPerformanceCounter(&Start);
  do {
    QueryPerformanceCounter(&L);

    lblElapseTime->Caption = Format("Elpased time: %d ms",
      OPENARRAY(TVarRec, ((int)(L.QuadPart - Start.QuadPart) / Freq)));

    Application->ProcessMessages();
  } while (!bStopCounter && !Application->Terminated);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnStopClick(TObject *Sender)
{
  bStopCounter = true;
}
//---------------------------------------------------------------------------

