//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

#include <mmsystem.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

DWORD TimerInterval = 10; // w]jɶ 10 @

int MMTimerID; // xs MMTimer  ID
DWORD StartTime;   // Ұʭpɾɥ GetTickCount oɶ
DWORD TriggerCount; // Ĳo
DWORD StopCount;  // Y 0, ĲoƨFȫ۰ʰ

void _stdcall TimerProc(HWND Window, UINT message, UINT idEvent, DWORD dwTime)
{
  Form1->CommonTimerProc();
}

void _stdcall MMTimerProc(UINT uTimerID, UINT uMessage, DWORD dwUser, DWORD dw1, DWORD dw2)
{
  Form1->CommonTimerProc();
}

void __fastcall TForm1::WMTimer(TWMTimer& message)
{
  CommonTimerProc();
}

void TForm1::CommonTimerProc()
{
  DWORD TimeDiff; // ڪOɶ

  // pڪOɶ
  TimeDiff = GetTickCount() - StartTime;
  lblElapsed->Caption = "Time : " + IntToStr(TimeDiff) + " ms";

  // ֥[pƾ
  TriggerCount++;
  lblCount->Caption = "Count: " + IntToStr(TriggerCount) + " times";

  // ~t = ڹڪOɶ - pƾ * jɶ
  lblError->Caption = "Error: " + IntToStr(TimeDiff - TriggerCount *
    TimerInterval) + " ms";

  if (StopCount != 0 && TriggerCount == StopCount)
    btnStopClick(btnStop);
}

void __fastcall TForm1::btnStartClick(TObject *Sender)
{
  TimerInterval = StrToIntDef(txtInterval->Text, 10);
  StopCount = StrToIntDef(txtStopCount->Text, 0);

  rgpTimerType->Enabled = false;
  TriggerCount = 0;
  StartTime = GetTickCount();

  // ھڿܲͤPpɾ
  switch (rgpTimerType->ItemIndex) {
    case 0: SetTimer(Handle, 1, TimerInterval, NULL);
            break;

    case 1: SetTimer(Handle, 1, TimerInterval, (TIMERPROC)&TimerProc);
            break;

    case 2: MMTimerID = timeSetEvent(TimerInterval, 0, (LPTIMECALLBACK)&MMTimerProc, 0,
      TIME_PERIODIC | TIME_CALLBACK_FUNCTION);
            break;
  }

  btnStop->Enabled = true;
}

void __fastcall TForm1::btnStopClick(TObject *Sender)
{
  switch (rgpTimerType->ItemIndex) {
    case 0: case 1: KillTimer(Handle, 1);
       break;

    case 2: if (MMTimerID != 0)
             timeKillEvent(MMTimerID);
  }

  rgpTimerType->Enabled = true;
  btnStop->Enabled = false;
}
//---------------------------------------------------------------------------
