//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
const AnsiString FN_NOTES = "notes.dat";
//---------------------------------------------------------------------------
TNoteForm* __fastcall TMainForm::CreateNewNote()
{
  // S VCL , Hୱ
  TNoteForm* frm = new TNoteForm(HWND_DESKTOP);

  // ]wsKȵm
  frm->Left = Left;
  frm->Top = Top - frm->Height;
  if (frm->Top < 0)
    frm->Top = Top + Height;

  UpdateWindow(frm->Handle); // ߧYø
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ListNotes()
{
  lbxNotes->Items->BeginUpdate();
  lbxNotes->Items->Clear();

  for (int i = 0; i < Screen->FormCount; i++)
    if (Screen->Forms[i] != this)
      lbxNotes->Items->AddObject(Screen->Forms[i]->Caption, Screen->Forms[i]);

  lbxNotes->Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::LoadNotes()
{
  TNoteForm* NewNote;
  TFileStream* fs = new TFileStream(FN_NOTES, fmOpenRead);

  try {
    while (fs->Position < fs->Size) {
      // n streaming, إ߷sKȵ
      NewNote = new TNoteForm((TComponent*)NULL, 0 /* dummy, invoking CreateNew */);
      NewNote->ParentWindow = HWND_DESKTOP;

      fs->ReadComponent(NewNote); // ŪKȵe
    }
  } __finally {
    delete fs;
  }

  ListNotes(); // sCXثeKȵ
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveNotes()
{
  TFileStream* fs = new TFileStream(FN_NOTES, fmCreate | fmOpenWrite);
  try {
    for (int i = 0; i < Screen->FormCount; i++) // {C@ form
      if (Screen->Forms[i] != this) // gJD
        fs->WriteComponent(Screen->Forms[i]); // NKȵegJ
  } __finally {
    delete fs;
  }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  RegisterClass(__classid(TNoteForm));
  
  LoadNotes();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  SaveNotes();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMNoteChanged(TMessage& Message)
{
  ListNotes();
}
void __fastcall TMainForm::btnNewNoteClick(TObject *Sender)
{
  CreateNewNote();

  ListNotes();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::lbxNotesDblClick(TObject *Sender)
{
  if (lbxNotes->ItemIndex == -1) return;

  ((TNoteForm*)lbxNotes->Items->Objects[lbxNotes->ItemIndex])->BringToFront();
}
//---------------------------------------------------------------------------

