//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "notefrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNoteForm *NoteForm;

const int SC_CHANGE_CAPTION = 0x10;

//---------------------------------------------------------------------------
__fastcall TNoteForm::TNoteForm(TComponent* Owner)
        : TForm(Owner)
{
  mmoNote->Color = RGB(255, 255, 123); // w]H
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::mmoNoteKeyPress(TObject *Sender, char &Key)
{
  if (Key == '\n' && Caption == "New Note" && mmoNote->Lines->Count > 0) {
    Caption = mmoNote->Lines->Strings[0];
    PostMessage(Application->MainForm->Handle, WM_NOTE_CHANGED, 0, 0);
  }
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  // YU ALT-C ...
  if (Key == 'C' && Shift.Contains(ssAlt))
    Perform(WM_SYSCOMMAND, SC_CHANGE_CAPTION, 0);
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::AddMyMenuItem()
{
  HMENU SysMenu;
  TMenuItemInfo MenuItemInfo;

  SysMenu = GetSystemMenu(Handle, false); // otο handle

  MenuItemInfo.cbSize = sizeof(MenuItemInfo);
  MenuItemInfo.fMask = MIIM_TYPE;
  MenuItemInfo.fType = MFT_SEPARATOR; // ju
  InsertMenuItem(SysMenu, (DWORD)-1, true, &MenuItemInfo); // [Ju

  MenuItemInfo.fMask = MIIM_ID | MIIM_TYPE;
  MenuItemInfo.fType = MFT_STRING; // r
  MenuItemInfo.wID = SC_CHANGE_CAPTION;
  MenuItemInfo.dwTypeData = "DD\tAlt+C";
  InsertMenuItem(SysMenu, (DWORD)-1, true, &MenuItemInfo); // [Jﶵ
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::CreateParams(TCreateParams &Params)
{
  TForm::CreateParams(Params);

  // ]wTΩ
  Params.Style = WS_SYSMENU | WS_SIZEBOX | WS_VISIBLE | WS_CLIPSIBLINGS;
  Params.ExStyle = WS_EX_TOOLWINDOW | WS_EX_WINDOWEDGE | WS_EX_NOPARENTNOTIFY;

  // mୱW
  Params.WndParent = HWND_DESKTOP;
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::CreateWnd(void)
{
  TForm::CreateWnd();

  SetWindowPos(Handle, HWND_BOTTOM, 0, 0, 0, 0,
    SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW);

  // [J"D"涵
  AddMyMenuItem();
}

//---------------------------------------------------------------------------
void __fastcall TNoteForm::WMSysCommand(TWMSysCommand& Message)
{
  if ((Message.CmdType & 0xFFF0) == SC_CHANGE_CAPTION) { // ϥΪ̿DDﶵ
     // ߰ݨçsDD
     Caption = InputBox(Application->Title, "DD", Caption);
     // qDsܦC
     PostMessage(Application->MainForm->Handle, WM_NOTE_CHANGED, 0, 0);
  } else
    TForm::Dispatch(&Message);
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::WMNCLButtonDblClk(TWMNCLButtonDblClk& Message)
{
  // YDC, PnDDD
  if (Message.HitTest == HTCAPTION)
    Perform(WM_SYSCOMMAND, SC_CHANGE_CAPTION, 0);
  else
    TForm::Dispatch(&Message);
}
//---------------------------------------------------------------------------
void __fastcall TNoteForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  Action = caMinimize;        
}
//---------------------------------------------------------------------------

void __fastcall TNoteForm::FormCreate(TObject *Sender)
{
  Caption = "New Note"; // w]D
}
//---------------------------------------------------------------------------

