//---------------------------------------------------------------------------

#ifndef ConfigDlgUH
#define ConfigDlgUH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CSPIN.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>

#include "DrawThrd.h"
//---------------------------------------------------------------------------
class TConfigDlg : public TForm
{
__published:	// IDE-managed Components
        TPageControl *pgcConfig;
        TTabSheet *TabSheet1;
        TGroupBox *gbxMoveSpeed;
        TLabel *lblSpeed;
        TTrackBar *trbSpeed;
        TGroupBox *gbxDelayTime;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TCSpinEdit *sedDelayTime;
        TCSpinEdit *sedChangeDelayTime;
        TCSpinEdit *sedClearDelayTime;
        TGroupBox *GroupBox3;
        TButton *btnChatFont;
        TPanel *pnlFont;
        TPaintBox *pbxFont;
        TEdit *txtFont;
        TTabSheet *TabSheet2;
        TMemo *mmoEssay;
        TGroupBox *GroupBox4;
        TListBox *lbxFiles;
        TBitBtn *btnAdd;
        TBitBtn *BitBtn2;
        TBitBtn *BitBtn3;
        TButton *btnOK;
        TButton *btnCancel;
        TOpenDialog *dlgOpen;
        TFontDialog *dlgFont;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall trbSpeedChange(TObject *Sender);
        void __fastcall btnAddClick(TObject *Sender);
        void __fastcall BitBtn3Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall lbxFilesClick(TObject *Sender);
        void __fastcall btnChatFontClick(TObject *Sender);
        void __fastcall pbxFontPaint(TObject *Sender);
private:	// User declarations
    TDrawThread* FDrawThread;

    void __fastcall LoadIni();
    void __fastcall SaveIni();
public:		// User declarations
        __fastcall TConfigDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TConfigDlg *ConfigDlg;
//---------------------------------------------------------------------------
#endif
