//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

#include <MMSystem.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

const int SPEED = 5; // ̤jʳtv

int TimerID;             // pɾs
int PointNum;            // Iƥ
TPoint Points[20], Steps[20];

int pnlWidth, pnlHeight; // xs pnlCanvas eפΰ
HWND pnlHandle;          // xs pnlCanvas  handle

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnCapsClick(TObject *Sender)
{
  TTimeCaps Caps;

  // oܦhCpɾҤ䴩ѪRפWU
  if (timeGetDevCaps(&Caps, sizeof(TTimeCaps)) == TIMERR_NOERROR) {
    ShowMessage("minimum supported resolution: " +
    IntToStr(Caps.wPeriodMin)
     + "\nmaximum supported resolution: " +
    IntToStr(Caps.wPeriodMax));
  } else
    ShowMessage("Size of TTimeCaps structure error.");
}
//---------------------------------------------------------------------------
// ѦhCpɾϥΪ^I禡
void InvertDirection(int &Step)
{
  Step = (Step > 0) ? -1 : 1;
  Step = (random(SPEED) + 1) * Step;
}

// ѦhCpɾϥΪ^I禡
void _stdcall TimerProc(UINT uTimerID, UINT uMessage, DWORD dwUser, DWORD dw1, DWORD dw2)
{
  for (int i = 0; i <= PointNum - 2; i++)
  {
    // sCӺIy
    Points[i].x += Steps[i].x;
    Points[i].y += Steps[i].y;

    // PyЬO_WX pnlCanvas d, pGWX, hϦV䲾ʤV,
    // ísHüƨotv
    if (Points[i].x <= 0 || Points[i].x >= pnlWidth)
      InvertDirection((int)Steps[i].x);

    if (Points[i].y <= 0 || Points[i].y >= pnlHeight)
      InvertDirection((int)Steps[i].y);
  }

  Points[PointNum - 1] = Points[0];

  // N pnlCanvas Mզísøs Bezier u
  HDC DC = GetDC(pnlHandle);
  TRect R;
  GetClientRect(pnlHandle, &R);
  FillRect(DC, &R, GetStockObject(WHITE_BRUSH));
  PolyBezier(DC, Points, PointNum);
  ReleaseDC(pnlHandle, DC);
}

void __fastcall TForm1::btnStartClick(TObject *Sender)
{
  // ]wһݤT
  if (timeBeginPeriod(StrToInt(cbxResolution->Text)) != TIMERR_NOERROR) {
    ShowMessage("Something wrong happened when setting timer period !!");
    return;
  }

  btnStart->Enabled = false;
  btnStop->Enabled = true;
  cbxResolution->Enabled = false;

  // OU pnlCanvas  handle μeI
  pnlHandle = pnlCanvas->Handle;
  pnlWidth = pnlCanvas->ClientWidth;
  pnlHeight = pnlCanvas->ClientHeight;

  PointNum = StrToInt(cbxPointNum->Text);
  for (int i = 0; i <= PointNum - 2; i++)
  {
    // HüƨoCӺIlm
    Points[i].x = random(pnlWidth);
    Points[i].y = random(pnlHeight);

    // HüƨoCӺIʳtvΤV
    if (random < 0.5)
      Steps[i].x = random(SPEED) + 1;
    else
      Steps[i].x = - (random(SPEED) + 1);

    if (random < 0.5)
      Steps[i].y = random(SPEED) + 1;
    else
      Steps[i].y = - (random(SPEED) + 1);
  }
  // ̫@IPĤ@IX
  Points[PointNum - 1] = Points[0];

  // ]wpɾ, YJjɶXk, h] 10 @
  TimerID = timeSetEvent(StrToIntDef(txtInterval->Text, 10),
    StrToInt(cbxResolution->Text), TimerProc, 0, TIME_PERIODIC);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  cbxResolution->ItemIndex = 0;
  cbxPointNum->ItemIndex = cbxPointNum->Items->Count - 1;

  // üƲ;l
  randomize();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnStopClick(TObject *Sender)
{
  // Rpɾ
  timeKillEvent(TimerID);
  // YIs timeBeginPeriod, OobpɾRIs timeEndPeriod,
  //  öǤJۦPѼ
  timeEndPeriod(StrToInt(cbxResolution->Text));

  btnStart->Enabled = true;
  btnStop->Enabled = false;
  cbxResolution->Enabled = true;
}
//---------------------------------------------------------------------------
