//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ExtDlgs.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TLabel *lblCaption;
        TLabel *lblClassName;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *lblRect;
        TLabel *Label4;
        TLabel *Label3;
        TLabel *lblHandle;
        TLabel *Label5;
        TShape *speCapture;
        TLabel *Label6;
        TButton *Button1;
        TButton *Button2;
        TScrollBox *ScrollBox1;
        TImage *imgResult;
        TButton *btnCopyToClipBoard;
        TSavePictureDialog *dlgSavePicture;
        TTimer *tmrDelay;
        void __fastcall btnCopyToClipBoardClick(TObject *Sender);
        void __fastcall tmrDelayTimer(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall speCaptureMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
private:	// User declarations
  HWND FOldWnd;
  bool FCapturing;

  void __fastcall GrabImage(HWND Wnd);
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
