//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "notefrm.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TButton *btnNewNote;
        TListBox *lbxNotes;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall btnNewNoteClick(TObject *Sender);
        void __fastcall lbxNotesDblClick(TObject *Sender);
private:	// User declarations
  TNoteForm* __fastcall CreateNewNote();
  void __fastcall ListNotes();

  void __fastcall LoadNotes();
  void __fastcall SaveNotes();

  void __fastcall WMNoteChanged(TMessage& Message);
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(WM_NOTE_CHANGED, TMessage, WMNoteChanged);
END_MESSAGE_MAP(TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
