//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
USERES("XEssay.res");
USEFORM("main.cpp", MainForm);
USEFORM("PreviewFrm.cpp", PreviewForm);
USEFORM("ConfigDlgU.cpp", ConfigDlg);
USEUNIT("DrawThrd.cpp");
USEUNIT("..\..\unit\xFonts.pas");
USEUNIT("util.cpp");

#pragma resource "title.res"

#include "ConfigDlgU.h"
#include "util.h"

// NĤGӰѼনƦsJ ParamHandle ܼ
bool SetParamHandle()
{
  bool r = ParamCount() > 1;
  try {
    if (r) ParamHandle = (HWND)StrToInt(ParamStr(2));
  } catch (...) {
    return false;
  }
  return true;
}

void ParseParameter()
{
  AnsiString Param;

  ParentHandle = 0;

  if (!ParamCount()) { // SѼ => ]wҦ
    SaverMode = smConfig;
    return;
  }

  Param = UpperCase(ParamStr(1));

  // YĤ@ӦrO^r, NR
  if (Param[1] < 'A' || Param[1] > 'Z') Param.Delete(1, 1);

  switch (Param[1]) {
    case 'C':
      SaverMode = smConfig;
      ParentHandle = GetForegroundWindow();
      break;

    case 'P': if (SetParamHandle()) // Y\ow handle
                SaverMode = smPreview; // iJwҦ
              break;

    default:
      SaverMode = smSaver; // _hiJùO@Ҧ
      break;
  }
}

//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  // RѼ, ھڰѼƭק SaverMode
  ParseParameter();

  TConfigDlg* ConfigDlg;

  try
  {
    switch (SaverMode) {
      case smSaver:
             Application->Initialize();
             Application->CreateForm(__classid(TMainForm), &MainForm);
             Application->Run();
             break;

      case smConfig:
        ConfigDlg = new TConfigDlg(NULL);
        try {
          ConfigDlg->ShowModal();
        } __finally {
          delete ConfigDlg;
        }
        break;

      case smPreview:
        PreviewSaver();
        break;
    }
  } catch (Exception &exception)
  {
           Application->ShowException(&exception);
  }
  return 0;
}
//---------------------------------------------------------------------------
