//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#define utilCPP
#include "util.h"
#include "DrawThrd.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

LRESULT _stdcall PreviewWndProc(HWND Wnd, UINT Msg, Longint WPARAM, Longint LPARAM)
{
  if (Msg == WM_DESTROY) {
    PostQuitMessage(0);
    return 0;
  }
  
  return DefWindowProc(Wnd, Msg, WPARAM, LPARAM);
}

void PreviewSaver()
{
  const char* PREVIEW_CLASSNAME = "XEssayScreenSaverPreview";

  TWndClass WndClass;
  HWND MyWnd;
  TMsg Msg;
  TRect R;

  WndClass.style = 0;
  WndClass.lpfnWndProc = (WNDPROC)PreviewWndProc;
  WndClass.cbClsExtra = 0;
  WndClass.cbWndExtra = 0;
  WndClass.hIcon = 0;
  WndClass.hInstance = HInstance;
  WndClass.hCursor = 0;
  WndClass.hbrBackground = 0;
  WndClass.lpszMenuName = NULL;
  WndClass.lpszClassName = PREVIEW_CLASSNAME;

  RegisterClass(&WndClass);

  GetWindowRect(ParamHandle, &R);

  MyWnd = CreateWindow(PREVIEW_CLASSNAME, "XEssaySaver",
    WS_CHILD | WS_DISABLED | WS_VISIBLE, 0, 0,
    R.Right - R.Left, R.Bottom - R.Top,
    ParamHandle, 0, HInstance, NULL);

  // إ߹B@֤߰
  TDrawThread* DrawThread = new TDrawThread(MyWnd);
  // Tj
  while (GetMessage(&Msg, 0, 0, 0)) {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
  }
  DrawThread->Terminate(); // B@֤߰

  // ~UO
  UnregisterClass(PREVIEW_CLASSNAME, HInstance);
}
