//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
USERES("Project1.res");
USEFORM("Unit1.cpp", Form1);
USEUNIT("..\..\unit\xFiles.pas");
//---------------------------------------------------------------------------

#include "xFiles.hpp"

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  AnsiString FontFileName;

  TResourceStream* rs = new TResourceStream((int)HInstance, "X_FILES", "FONTDATA");
  try {
    FontFileName = ChangeFileExt(GetTemporaryFileName("X"), ".TTF");
    rs->SaveToFile(FontFileName);
    AddFontResource(FontFileName.c_str());
  } __finally {
    delete rs;
  }

        try
        {
                 Application->Initialize();
                 Application->CreateForm(__classid(TForm1), &Form1);
                 Application->Run();
        }
        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }

  RemoveFontResource(FontFileName.c_str());
  DeleteFile(FontFileName.c_str());

        return 0;
}
//---------------------------------------------------------------------------
