//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *pnlEssay;
        TMemo *mmoEssay;
        TMainMenu *mnuMain;
        TMenuItem *F1;
        TMenuItem *mnuWrite;
        TMenuItem *N2;
        TMenuItem *mnuHide;
        TMenuItem *mnuExit;
        TMenuItem *mnuEdit;
        TMenuItem *mnuInsertSeperator;
        TMenuItem *C1;
        TMenuItem *mnuFont;
        TMenuItem *mnuSeperatorColor;
        TMenuItem *N1;
        TMenuItem *mnuShowDesktopWallPaper;
        TFontDialog *dlgFont;
        TColorDialog *dlgSepColor;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall mnuWriteClick(TObject *Sender);
        void __fastcall mnuSeperatorColorClick(TObject *Sender);
        void __fastcall mnuFontClick(TObject *Sender);
        void __fastcall mnuHideClick(TObject *Sender);
        void __fastcall mnuInsertSeperatorClick(TObject *Sender);
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall mnuShowDesktopWallPaperClick(TObject *Sender);
private:	// User declarations
   void __fastcall ApplyColor();
   void __fastcall ApplyFont();
   void __fastcall ApplyEssay();

   void __fastcall WMSysCommand(TWMSysCommand& Message);
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(WM_SYSCOMMAND, TWMSysCommand, WMSysCommand);
END_MESSAGE_MAP(TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
