//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSysCommand(TWMSysCommand& Message)
{
  if (Message.CmdType == SC_SCREENSAVE)
    Message.Result = 0;
  else
    TForm::Dispatch(&Message);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMActivate(TWMActivate& Message)
{
  if (Message.Active == WA_INACTIVE)
    Close();
  else
    TForm::Dispatch(&Message);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMNCActivate(TWMNCActivate& Message)
{
  if (Message.Active == false)
    Close();
  else
    TForm::Dispatch(&Message);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMActivateApp(TWMActivateApp& Message)
{
  if (Message.Active == false)
    Close();
  else
    TForm::Dispatch(&Message);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormActivate(TObject *Sender)
{
  ShowCursor(false); // Nƹð_

  FDrawThread = new TDrawThread(Handle); // إ֤߮߰
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  FDrawThread->Terminate(); // ֤߰
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  static int OrgX = -1;
  static int OrgY = -1;

  if (OrgX == -1) {
    OrgX = X;
    OrgY = Y;
  } else
    if (OrgX != X || OrgY != Y) Close();

}
//---------------------------------------------------------------------------

