#include <windows.h>

#include <vcl.h>

#include "dihook.h"

const int MAX_ESSAY_LINE  = 100;                      // ̤ju
const int MAX_ESSAY_CHAR  = 100;                      // ̪ur
const char* HOOK_EVENT_NAME = "SetWindowsHookEx_Event";

// ưϰ, ѩҦ DLL instance @

typedef struct {
    HHOOK HHOOK; // Hook handle
    HWND MainWnd; // {D handle

    HWND Wnd; // I handle
    WNDPROC OrigWndProc; // I쥻禡

    HWND ParentWnd; // I handle
    WNDPROC OrigParentWndProc; // I쥻禡

    // ୱ
    bool ShowDesktopWallPaper; // O_ܮ६

    COLORREF SeperatorColor; // juC
    TRect WorkAreaRect;

    // uT
    char Essay[MAX_ESSAY_LINE][MAX_ESSAY_CHAR]; // u
    int Essay_LineCount; // 

    TLogFont Essay_Font; // r
    COLORREF Essay_Color; // C
} TGlobalData, *PGlobalData;

  // ʺA, _ܤƪe
typedef struct {
  TPoint Position; // ܦm

  Graphics::TBitmap* DesktopBits; // ୱIv
  Graphics::TBitmap* BackBits; // double-buffering KϨϥ

  AnsiString DisplayString; // ɶr

  TRect LastRect; // Wܰϰ
  TRect CurRect; // ܰϰ
} TDynDisplay;

const int WM_MYHOOK            = WM_APP;     // hook wˤθѰ᪺qT
const int WM_SUBCLASSED        = WM_USER;          // subclass 禡᪺qT
const int WM_BEFORE_UNSUBCLASS = WM_USER + 1;      // unsubclass 禡eqT

const char* GLOBAL_DATA_MAPNAME = "XDESK_HOOK_GLOBAL_DATA"; // @ file mapping W

const int  TIMER_ID             = 500;                      // pɾs

HINSTANCE g_hinstDLL;
PGlobalData g_Data; // V@ TGlobalData c
HANDLE MapHandle;     // file mapping handle

TDynDisplay DynDisplay; // ʺAeT

class TConfigButton : public TButton { // ]wsO
private:
  void __fastcall WMPaint(TWMPaint& Message);
  void __fastcall WMLButtonUp(TWMLButtonUp& Message);
protected:
  virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
public:
/* TWinControl.CreateParented */ inline __fastcall TConfigButton(HWND ParentWindow) :
      TButton(ParentWindow) { }

BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(WM_PAINT, TWMPaint, WMPaint);
    VCL_MESSAGE_HANDLER(WM_LBUTTONUP, TWMLButtonUp, WMLButtonUp);
END_MESSAGE_MAP(TButton);
};

TConfigButton* ConfigButton; // ]ws

void __fastcall TConfigButton::WMLButtonUp(TWMLButtonUp& Message)
{
  TButton::Dispatch(&Message);

  if (g_Data->MainWnd != 0) { // ܳ]w
    if (IsWindowVisible(g_Data->MainWnd))
      SetForegroundWindow(g_Data->MainWnd);
    else
      ShowWindow(g_Data->MainWnd, SW_SHOW);
  }
}

void __fastcall TConfigButton::WMPaint(TWMPaint& Message)
{
  TButton::Dispatch(&Message);

  TRect R;

  // s\bୱϥܤW, Ysø, ]øWୱϥ
  R = BoundsRect;
  InvalidateRect(g_Data->Wnd, &R, false);
}

void __fastcall TConfigButton::CreateParams(Controls::TCreateParams &Params)
{
  TButton::CreateParams(Params);

  Params.Style = Params.Style & ~WS_CLIPSIBLINGS & ~WS_BORDER & ~WS_DLGFRAME; // ݭnޥS̵, ӵe~
}

#define MAX(a, b) ((a) > (b) ? (a) : (b))

  // øsu
void DrawEssay(HDC DC)
{
  HFONT OldFont;
  HPEN OldPen;

  int Y, X, MaxLen, LineHeight;
  TTextMetric TextMetric;

  TSize Size;

  SetBkMode(DC, TRANSPARENT);
  SetTextColor(DC, g_Data->Essay_Color);

  OldFont = SelectObject(DC, CreateFontIndirect(&g_Data->Essay_Font));
  OldPen = SelectObject(DC, CreatePen(PS_SOLID, 1, g_Data->SeperatorColor));

  MaxLen = 0;
  for (int i = 0; i < g_Data->Essay_LineCount; i++) {
    GetTextExtentPoint32(DC, g_Data->Essay[i], strlen(g_Data->Essay[i]), &Size);
    if (Size.cx > MaxLen) MaxLen = Size.cx;

    X = MAX((Screen->Width - MaxLen) / 2, 0);
    GetTextMetrics(DC, &TextMetric);
    LineHeight = TextMetric.tmHeight + TextMetric.tmExternalLeading;

    Y = TextMetric.tmHeight;
    for (i = 0; i < g_Data->Essay_LineCount; i++) {
      if (strlen(g_Data->Essay[i]) == 1 && g_Data->Essay[i][0] == '-') {
        MoveToEx(DC, X, Y + LineHeight / 2, NULL);
        LineTo(DC, X + MaxLen, Y + LineHeight / 2);
      } else
        TextOut(DC, X, Y, g_Data->Essay[i], strlen(g_Data->Essay[i]));

      Y += LineHeight;
    }

    DeleteObject(SelectObject(DC, OldFont));
    DeleteObject(SelectObject(DC, OldPen));
  }
}

LRESULT _stdcall WndProc(HWND Window, UINT AMessage, Longint WPARAM , Longint LPARAM)
{
  HDC DC;
  TRect R;

  TSize DisplaySize;

  switch (AMessage) {

    case WM_SETTINGCHANGE: // tγ]w
    case WM_SYSCOLORCHANGE: // tC(DnwୱC)

        SystemParametersInfo(SPI_GETWORKAREA, 0, &g_Data->WorkAreaRect, NULL);

        // Nୱøs DesktopBits
        PaintDesktop(DynDisplay.DesktopBits->Canvas->Handle);

        // oɶrꪺܤؤo
        DisplaySize = DynDisplay.BackBits->Canvas->TextExtent(TimeToStr(Now()));

        // pɶrꪺܦm
        DynDisplay.Position = Point(g_Data->WorkAreaRect.Right - DisplaySize.cx - 20 - g_Data->WorkAreaRect.Left, g_Data->WorkAreaRect.Bottom - DisplaySize.cy - 20 - g_Data->WorkAreaRect.Top);
        // p]wsm
        ConfigButton->Left = g_Data->WorkAreaRect.Right - ConfigButton->Width - 20 - g_Data->WorkAreaRect.Left;
        ConfigButton->Top = DynDisplay.Position.y - ConfigButton->Height - 10;

        ShowWindow(ConfigButton->Handle, SW_SHOW);
        break;

    case WM_TIMER:
      DynDisplay.DisplayString = TimeToStr(Now()); // oثeɶr

      // oɶrꪺܤؤo
      DisplaySize = DynDisplay.BackBits->Canvas->TextExtent(DynDisplay.DisplayString);

        // oeΦܰϰ쪺涰
      DynDisplay.CurRect = Rect(0, 0, DisplaySize.cx, DisplaySize.cy);
      OffsetRect(&DynDisplay.CurRect, DynDisplay.Position.x, DynDisplay.Position.y);
      UnionRect(&DynDisplay.CurRect, &DynDisplay.CurRect, &DynDisplay.LastRect);
      InvalidateRect(Window, &DynDisplay.CurRect, false);

      DynDisplay.LastRect = DynDisplay.CurRect;

      return 0;

    case WM_SUBCLASSED:
//      DebugStr("WM_SUBCLASSED");
      SetTimer(Window, TIMER_ID, 1000, NULL);

      ConfigButton = new TConfigButton(g_Data->ParentWnd);
      ConfigButton->Font->Name = "sө";
      ConfigButton->Font->Size = 11;
      ConfigButton->Caption = "]w";

      // إxsୱv bitmap
      DynDisplay.DesktopBits = new Graphics::TBitmap;
      DynDisplay.DesktopBits->Width = Screen->Width;
      DynDisplay.DesktopBits->Height = Screen->Height;

      // إߥΨӰ double-buffering KϪ bitmap
      DynDisplay.BackBits = new Graphics::TBitmap;
      // ]wnɶܪrΤC
      DynDisplay.BackBits->Canvas->Font->Height = 48;
      DynDisplay.BackBits->Canvas->Font->Color = clRed;
      DynDisplay.BackBits->Canvas->Font->Name = "WA";

      // joୱv, ms
      SendMessage(Window, WM_SETTINGCHANGE, 0, 0);
      break;

    case WM_BEFORE_UNSUBCLASS:
//      DebugStr("WM_BEFORE_UNSUBCLASS");
      KillTimer(Window, TIMER_ID);

      delete ConfigButton;
      ConfigButton = NULL;

      delete DynDisplay.DesktopBits;
      delete DynDisplay.BackBits;
      break;

    case WM_ERASEBKGND: // MI
      DC = (HDC)WPARAM; // ϥΰT DC

      if (g_Data->ShowDesktopWallPaper)
        // Ynݨ६, NIsӪ禡
        CallWindowProc((FARPROC)g_Data->OrigWndProc, Window, AMessage, WPARAM, LPARAM);
      else {
        // Ynݨ६, NୱC
        R = Rect(0, 0, Screen->Width, Screen->Height);
        HANDLE BackgroundBrush = CreateSolidBrush(GetSysColor(COLOR_DESKTOP));
        FillRect(DC, &R, BackgroundBrush);
        DeleteObject(BackgroundBrush);
      }

      // NuebIW
      if (g_Data->Essay_LineCount > 0)
        DrawEssay(DC);

      // ø]ws
      if (ConfigButton) {
        ConfigButton->Invalidate();
        ConfigButton->Update();
      }

      // IM
      return 1;

    default:

    if (AMessage >= WM_MOUSEFIRST && AMessage <= WM_MOUSELAST) { // dIҦƹT
      // oToͪƹЦm
      TLVHitTestInfo HitTestInfo;
      
      HitTestInfo.pt = Point(LOWORD(LPARAM), HIWORD(LPARAM));

      if (ConfigButton && SendMessage(Window, LVM_HITTEST, 0, Integer(&HitTestInfo)) == -1) {
        // YToͦb]wsW ...
        R = ConfigButton->BoundsRect;

        if (PtInRect(&R, HitTestInfo.pt)) {
          // ⦨۹ ConfigButton client area yЭ
          ClientToScreen(Window, &HitTestInfo.pt);
          ScreenToClient(ConfigButton->Handle, &HitTestInfo.pt);

          // NT浹 ConfigButton
          // b PostMessage ӥ SendMessage ]O, ƱbsBz
          // TߧYøsϰ쪺ୱ
          LPARAM = MAKELONG(HitTestInfo.pt.x, HitTestInfo.pt.y);
          SendMessage(ConfigButton->Handle, AMessage, WPARAM, LPARAM);

          // øsϰ쪺ୱ
          R = ConfigButton->BoundsRect;
          InvalidateRect(Window, &R, false);

          // \BzT
          return 0;
        }
      }
    }
  }

  return CallWindowProc((FARPROC)g_Data->OrigWndProc, Window, AMessage, WPARAM, LPARAM);
}

LRESULT _stdcall ParentWndProc(HWND Window, UINT AMessage, Longint WPARAM , Longint LPARAM)
{
  PNMHdr NMHdr;
  TRect RSrc, RDst;

  switch (AMessage) {
    case WM_NOTIFY:

      NMHdr = PNMHdr(LPARAM);
      switch (NMHdr->code) {
        // ListView iøsɷ|e WM_NOTIFY T
        // ʧ@NX NM_CUSTOMDRAW
        case NM_CUSTOMDRAW:
          // Yxΰϰ, hܧ BackBits jp
          if (DynDisplay.BackBits->Width != DynDisplay.CurRect.Right - DynDisplay.CurRect.Left || DynDisplay.BackBits->Height != DynDisplay.CurRect.Bottom - DynDisplay.CurRect.Top) {
            DynDisplay.BackBits->Width = DynDisplay.CurRect.Right - DynDisplay.CurRect.Left;
            DynDisplay.BackBits->Height = DynDisplay.CurRect.Bottom - DynDisplay.CurRect.Top;
          }

          RSrc = Rect(0, 0, DynDisplay.BackBits->Width, DynDisplay.BackBits->Height);

          if (g_Data->ShowDesktopWallPaper) { // Ynܮ६
            // NI DynDisplay.BackBits
            RDst = RSrc;
            OffsetRect(&RDst, DynDisplay.Position.x + g_Data->WorkAreaRect.Left, DynDisplay.Position.y + g_Data->WorkAreaRect.Top);
            DynDisplay.BackBits->Canvas->CopyRect(RSrc, DynDisplay.DesktopBits->Canvas, RDst);
          }

          // Ynܮ६, ĳzKr
          if (g_Data->ShowDesktopWallPaper)
            DynDisplay.BackBits->Canvas->Brush->Style = bsClear;
          else {
            // _hNv񺡭I
            DynDisplay.BackBits->Canvas->Brush->Style = bsSolid;
            DynDisplay.BackBits->Canvas->Brush->Color = clBackground;
          }

          // b DynDisplay.BackBits WøXɶr
          DynDisplay.BackBits->Canvas->TextRect(RSrc, 0, 0, DynDisplay.DisplayString);

          // ̫N DynDisplay.BackBits KୱW
          BitBlt(PNMLVCustomDraw(NMHdr)->nmcd.hdc, DynDisplay.Position.x, DynDisplay.Position.y, DynDisplay.BackBits->Width, DynDisplay.BackBits->Height,
              DynDisplay.BackBits->Canvas->Handle, 0, 0, SRCCOPY);

          // i楿`øsʧ@
          return CDRF_DODEFAULT;
      }
    break;
  }

  return CallWindowProc((FARPROC)g_Data->OrigParentWndProc, Window, AMessage, WPARAM, LPARAM);
}

LRESULT _stdcall GetMsgProc(int Code, Longint WPARAM , Longint LPARAM)
{
  static bool bFirstCalled = true;
  HANDLE hEvent;

  if (Code == HC_ACTION) { // ʧ@NX HC_ACTION ɤ~Bz
    if (bFirstCalled) { // Ĥ@Isɶi subclassing

      bFirstCalled = false;

      // subclass I
      g_Data->OrigWndProc = (WNDPROC)SetWindowLong(g_Data->Wnd, GWL_WNDPROC, (long)WndProc);

      // subclass I
      g_Data->ParentWnd = GetParent(g_Data->Wnd);
      g_Data->OrigParentWndProc = (WNDPROC)SetWindowLong(g_Data->ParentWnd, GWL_WNDPROC, (long)ParentWndProc);

      // iI, wQ subclass
      PostMessage(g_Data->Wnd, WM_SUBCLASSED, 0, 0);

      InvalidateRect(g_Data->Wnd, NULL, true); // ø ListView 

      // i hook {ǧ
      PostThreadMessage(PMsg(LPARAM)->wParam, WM_MYHOOK, 0, 0);

      // ն}ҫO@ hook handle  event
      hEvent = OpenEvent(SYNCHRONIZE, false, HOOK_EVENT_NAME);
      if (hEvent) { // pG}Ҧ\,  hook handle |QgJ
        WaitForSingleObject(hEvent, INFINITE); //  hook handle TwU
        CloseHandle(hEvent); //  event
      }
    } else if (PMsg(LPARAM)->message == WM_MYHOOK) {
      // qI, Nn unsubclass
      SendMessage(g_Data->Wnd, WM_BEFORE_UNSUBCLASS, 0, 0);

      // unsubclass I
      SetWindowLong(g_Data->Wnd, GWL_WNDPROC, (long)g_Data->OrigWndProc);
      // unsubclass I
      SetWindowLong(g_Data->ParentWnd, GWL_WNDPROC, (long)g_Data->OrigParentWndProc);

      InvalidateRect(g_Data->Wnd, NULL, true); // ø ListView 

      // i unhook {ǧ
      PostThreadMessage(PMsg(LPARAM)->wParam, WM_MYHOOK, 0, 0);
    }
  }

  // IsU@ hook 禡
  return CallNextHookEx(g_Data->HHOOK, Code, WPARAM, LPARAM);
}

EXTERN bool _stdcall SetDeskHook(HWND Wnd)
{
  DWORD ThreadId;
  TMsg Msg;
  HANDLE hEvent;

  if (Wnd != 0) {
    if (g_Data->HHOOK != 0) return false;

    // o ID
    g_Data->Wnd = Wnd;
    ThreadId = GetWindowThreadProcessId(g_Data->Wnd, NULL);

    // إ߫O@ hook handle  event
    hEvent = CreateEvent(NULL, true, false, HOOK_EVENT_NAME);
    // w WH_GETMESSAGE hook
    g_Data->HHOOK = SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)GetMsgProc, g_hinstDLL, ThreadId);
    // N event ] signaled A, Y hook 禡b, q,
    // hook handle wg ready
    SetEvent(hEvent);
    //  event
    CloseHandle(hEvent);

    if (g_Data->HHOOK != 0) { // Y hook w˦\
      // @ӵLΰTLh, T{ hook 禡QIs
      // P subclass IΨ
      PostThreadMessage(ThreadId, WM_NULL, GetCurrentThreadId(), 0);

      //  Hook ˳],  Hook {ǰe^ WM_MYHOOK Tq
      do {
         GetMessage(&Msg, 0, 0, 0);
      } while (Msg.message != WM_MYHOOK);

      return true;
    }
  } else {
    if (g_Data->HHOOK != 0) {
      ThreadId = GetWindowThreadProcessId(g_Data->Wnd, NULL);
      // i hook 禡, Х unsubclass, ǳƭn unhook F
      PostThreadMessage(ThreadId, WM_MYHOOK, GetCurrentThreadId(), 0);

      // Tw GetMsgProc wNIΨ unsubclassing ..
      do {
        GetMessage(&Msg, 0, 0, 0);
      } while (Msg.message != WM_MYHOOK);

      //  hook 禡
      UnhookWindowsHookEx(g_Data->HHOOK);

      g_Data->HHOOK = 0;

      return true;
    }
  }

  return true;
}

EXTERN void _stdcall SetMainWindow(HWND Wnd)
{
  g_Data->MainWnd = Wnd;
}

EXTERN void _stdcall SetShowDesktopWallPaper(bool Value)
{
  g_Data->ShowDesktopWallPaper = Value;
  InvalidateRect(g_Data->Wnd, NULL, true);
}

EXTERN void _stdcall SetEssay(int index, char* Str)
{
  if (index < MAX_ESSAY_LINE)
    strncpy(g_Data->Essay[index], Str, MAX_ESSAY_CHAR - 1);
}

#define MIN(a,b) ((a)<(b)?(a):(b))

EXTERN void _stdcall SetEssayCount(int Count)
{
  g_Data->Essay_LineCount = MIN(Count, MAX_ESSAY_LINE);
  InvalidateRect(g_Data->Wnd, NULL, true);
}

EXTERN void _stdcall SetEssayFont(PLogFont LF)
{
  memcpy(&g_Data->Essay_Font, LF, sizeof(TLogFont));
  InvalidateRect(g_Data->Wnd, NULL, true);
}

void _stdcall SetEssayColor(COLORREF SepColor, COLORREF TextColor)
{
  g_Data->SeperatorColor = SepColor;
  g_Data->Essay_Color = TextColor;

  InvalidateRect(g_Data->Wnd, NULL, true);
}

HANDLE MapGlobalData(const AnsiString MapName, int Size, LPVOID &P)
{
  HANDLE ret = CreateFileMapping( (HANDLE)0xFFFFFFFF, NULL, PAGE_READWRITE, 0, Size, MapName.c_str());

  if (ret == 0) {
    if (GetLastError() == ERROR_ALREADY_EXISTS) {
      ret = OpenFileMapping(FILE_MAP_ALL_ACCESS, false, MapName.c_str());
      if (ret == 0) return ret;
    } else
      return ret;
  }

  P = (LPVOID)MapViewOfFile(ret, FILE_MAP_ALL_ACCESS, 0, 0, 0);
  if (P == NULL) {
    CloseHandle(ret);
    ret = 0;
  }

  return ret;
}

void ReleaseGlobalData(HANDLE handle, void* &Ptr)
{
  if (Ptr) {
    UnmapViewOfFile(Ptr);
    Ptr = NULL;
  }

  if (handle != 0) {
    CloseHandle(handle);
    handle = 0;
  }
}

void DebugStr(AnsiString S)
{
  S = S + "\n";
  OutputDebugString(S.c_str());
}

#pragma argsused
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
  char buf[256];

  GetModuleFileName(0, buf, sizeof(buf));
  switch (fwdreason) {
    case DLL_PROCESS_ATTACH:
      g_hinstDLL = hinstDLL;
      DebugStr(Format("DLL_PROCESS_ATTACH: %d %s", OPENARRAY(TVarRec, ((int)hinstDLL, buf))));
      MapHandle = MapGlobalData(GLOBAL_DATA_MAPNAME, sizeof(TGlobalData), Pointer(g_Data));
      break;

    case DLL_PROCESS_DETACH:
      DebugStr(Format("DLL_PROCESS_DETACH: %d %s", OPENARRAY(TVarRec, ((int)g_hinstDLL, buf))));
      ReleaseGlobalData(MapHandle, Pointer(g_Data));
      break;

    case DLL_THREAD_ATTACH:;
      break;

    case DLL_THREAD_DETACH:;
      break;
  }

  return 1;
}


