//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CGRID.h"
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TImage *imgMain;
        TPanel *pnlRight;
        TCColorGrid *grdColor;
        void __fastcall grdColorChange(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormKeyPress(TObject *Sender, char &Key);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall pnlRightResize(TObject *Sender);
        void __fastcall imgMainMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall imgMainMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall imgMainMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall FormActivate(TObject *Sender);
private:	// User declarations
  bool FDrawing;

  Graphics::TBitmap *FCursorBits, *FDesktopBits;
  TPoint FCursorPos;

  void __fastcall GrabScreenImage();

  void __fastcall WMSetFocus(TWMSetFocus& Message);
  void __fastcall WMKillFocus(TWMKillFocus& Message);
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(WM_SETFOCUS, TWMSetFocus, WMSetFocus);
    VCL_MESSAGE_HANDLER(WM_KILLFOCUS, TWMKillFocus, WMKillFocus);
END_MESSAGE_MAP(TForm);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
