//---------------------------------------------------------------------------

#ifndef utilH
#define utilH
//---------------------------------------------------------------------------
typedef enum {smSaver, smConfig, smPreview} TSaverMode;

#ifdef utilCPP
#define EXTERN
#else
#define EXTERN extern
#endif

#ifdef utilCPP
const char* REGISTRY_KEY        = "Software\\Jethro\\XEssaySaver\\";

const char* SEC_GENERAL         = "General";

const char* SEC_ESSAYFILES      = "EssayFiles";

const char* REG_MOVESPEED       = "MoveSpeed";
const char* REG_MOVEDELAYTIME   = "MoveDelayTime";
const char* REG_CLEARDELAYTIME  = "ClearDelayTime";
const char* REG_CHANGEDELAYTIME = "ChangeDelayTime";

const char* REG_DISPLAYFONT     = "DisplayFont";

const char* DEFAULT_DISPLAYFONT = "\"sө\", 11, [], [clWhite]";
#else
EXTERN const char* REGISTRY_KEY;

EXTERN const char* SEC_GENERAL;

EXTERN const char* SEC_ESSAYFILES;

EXTERN const char* REG_MOVESPEED;
EXTERN const char* REG_MOVEDELAYTIME;
EXTERN const char* REG_CLEARDELAYTIME;
EXTERN const char* REG_CHANGEDELAYTIME;

EXTERN const char* REG_DISPLAYFONT;

EXTERN const char* DEFAULT_DISPLAYFONT;
#endif

EXTERN TSaverMode SaverMode;
EXTERN HWND ParamHandle, ParentHandle;

EXTERN void PreviewSaver();

#endif
