unit xKernel;

interface

uses Windows, SysUtils;

procedure DebugStr(S: string);
procedure DebugStrFmt(const Format: string; const Args: array of const);

implementation

uses xStrings, xUtils;

procedure DebugStr(S: string);
begin
  if not IsContainingCRLF(S) then S := S + #13#10;
  OutputDebugString(PChar(S));
end;

procedure DebugStrFmt(const Format: string; const Args: array of const);
begin
  DebugStr(SysUtils.Format(Format, Args));
end;

end.

